HIT=$1

# cut: Separate each byte group (2 bytes) by spaces.
# perl: 0-pad each byte group from left if less than width 4
# sed: Separate each byte with spaces.
HIT=$(echo $HIT | cut --output-delimiter=' ' -d':' -f 1- | perl -nae 'for(@F){ printf "%04s", $_}' | sed 's/.\{2\}/& /g')
echo $HIT

BT_MAC=$(bluetoothctl list | cut -d' ' -f 2 | sed 's/\:/ /g')
echo $BT_MAC

# Reset
hcitool -i hci0 cmd 0x03 0x0003

# AD parameters, 1 second interval on all channels. 
hcitool -i hci0 cmd 0x08 0x0006 a0 00 a0 00 03 00 00 $BT_MAC 07 00

# ASTM F3-411 AD data packets (Basic ID message with HHIT).
hcitool -i hci0 cmd 0x08 0x0008 1e 16 ff fa 0d 00 00 42 $HIT 00 00 00 00 00 00 00 00

# Enable bluetooth advertisement.
hcitool -i hci0 cmd 0x08 0x000a 01
