from nacl.signing import SigningKey, VerifyKey
from bs4 import BeautifulSoup
from binascii import unhexlify, hexlify

if __name__ == '__main__':
  bs = None
  try:
    with open("/usr/local/etc/hip/my_host_identities.xml", 'r') as f:
      bs = BeautifulSoup(f.read(), 'lxml')
  except PermissionError as e:
    print(e)

  host_id = bs.find("host_identity") # use first host id
  priv_key = ''.join(host_id.find("priv").string.split(':'))
  pub_key = ''.join(host_id.find("pub").string.split(':'))

  # prepend 0's to all byte groups in HIT if the byte group len is less than 4.
  hit_byte_list = host_id.find("hit").string.split(':')
  for i in range(len(hit_byte_list)):
    while len(hit_byte_list[i]) < 4:
      hit_byte_list[i] = '0' + hit_byte_list[i]

  hit = ''.join(hit_byte_list)

  sign_key = SigningKey(unhexlify(priv_key))
  verify_key = VerifyKey(unhexlify(pub_key))

  sig = sign_key.sign(unhexlify(hit))
  hit_sig = hexlify(verify_key.verify(sig))